"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from emissary_client_sdk.types import BaseModel
from emissary_client_sdk.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from enum import Enum
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ServerType(str, Enum):
    SERVERLESS = "serverless"
    ON_DEMAND = "on-demand"


class CreateDeploymentRequestBodyTypedDict(TypedDict):
    r"""Provide you deployment details"""

    training_job_id: str
    r"""The training job ID to use for deployment"""
    checkpoint: int
    r"""The checkpoint number to use for deployment"""
    server_type: NotRequired[ServerType]
    name: NotRequired[str]
    r"""The name of the deployment"""
    description: NotRequired[str]
    r"""A description of the deployment"""


class CreateDeploymentRequestBody(BaseModel):
    r"""Provide you deployment details"""

    training_job_id: str
    r"""The training job ID to use for deployment"""

    checkpoint: int
    r"""The checkpoint number to use for deployment"""

    server_type: Optional[ServerType] = None

    name: Optional[str] = None
    r"""The name of the deployment"""

    description: Optional[str] = None
    r"""A description of the deployment"""


class CreateDeploymentRequestTypedDict(TypedDict):
    project_id: str
    r"""The ID of the project to create a deployment for"""
    request_body: CreateDeploymentRequestBodyTypedDict
    r"""Provide you deployment details"""


class CreateDeploymentRequest(BaseModel):
    project_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The ID of the project to create a deployment for"""

    request_body: Annotated[
        CreateDeploymentRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]
    r"""Provide you deployment details"""
